package org.sky.develop.service;

import com.baomidou.mybatisplus.generator.config.builder.ConfigBuilder;
import com.baomidou.mybatisplus.generator.config.po.TableInfo;
import org.sky.core.mp.base.BaseService;
import org.sky.develop.pojo.entity.Datasource;
import org.sky.develop.pojo.entity.ModelPrototype;

import java.util.List;

/**
 * 数据原型表 服务类
 *
 */
public interface IModelPrototypeService extends BaseService<ModelPrototype> {

	/**
	 * 批量提交
	 *
	 * @param modelPrototypes 原型集合
	 * @return boolean
	 */
	boolean submitList(List<ModelPrototype> modelPrototypes);

	/**
	 * 原型列表
	 *
	 * @param modelId 模型ID
	 * @return List<ModelPrototype>
	 */
	List<ModelPrototype> prototypeList(Long modelId);

	/**
	 * 获取表信息
	 *
	 * @param tableName    表名
	 * @param datasourceId 数据源主键
	 */
	TableInfo getTableInfo(String tableName, Long datasourceId);

	/**
	 * 获取表配置信息
	 *
	 * @param datasource 数据源信息
	 */
	default ConfigBuilder getConfigBuilder(Datasource datasource) {
		return getConfigBuilder(datasource, null);
	}

	/**
	 * 获取表配置信息
	 *
	 * @param datasource 数据源信息
	 * @param tableName  表名
	 */
	ConfigBuilder getConfigBuilder(Datasource datasource, String tableName);

}
